
import java.util.regex.*;

/**
 * Aby wykonać wiele unikalnych zastąpień w tym samym łańcuchu znaków,
 * należy zastosować pętlę i wywoływać metodę reset() instancji Matcher.
 */
public class ReplaceMulti {
    public static void main(String[] args) {
        Pattern patt = Pattern.compile("koty|psy");
        String line = "Dlaczego psy i koty nigdy nie żyją w zgodzie?";
        System.out.println("Input: " + line);
        Matcher matcher = patt.matcher(line);
        while (matcher.find()) {
            String found = matcher.group(0);
            String replacement = computeReplacement(found);
            line = matcher.replaceFirst(replacement);
            matcher.reset(line);
        }
        System.out.println("Final: " + line);
    }

    static String computeReplacement(String in) {
        switch(in) {
            case "koty": return "kotowate";
            case "psy": return "psowate";
            default: return "zwierzęta";
        }
    }
}